//
//  TftMSmartAI.java
//  UlimateRetro
//
//  Created by Billy Spelchan on Wed Oct 30 2002.
//  Copyright (c) 2002 Spelchan Software. All rights reserved.
//
package com.blazinggames.retro.modern.search;

// Java imports
import java.awt.Point;
import java.util.Vector;
import java.util.Random;

// retro imports
import com.blazinggames.retro.shared.search.tftm.*;

public class TftMSmartAI
extends TftMDumbAI
{
// *********************
// ***** VARIABLES *****
// *********************

    private Random _random;

    
// ************************
// ***** CONSTRUCTORs *****
// ************************
    
    public TftMSmartAI(Map map, int id, int money, int turnMoney, int factoryMoney, int tankCost)
    {
        super(map, id, money, turnMoney, factoryMoney, tankCost);
        _random = new Random();
    }


// **********************************
// ***** METHODS - From Dumb AI *****
// **********************************

    protected String continueTurn()
    {
//        System.out.println("continueTurn() for " + _id + " called!");
        Point loc, target;
        boolean tankMoving;

        // Make sure there is actually a tank to continue moving
        if ( (_curTank < 0) || (_curTank > 8) )
        {
            nextTank();
            return " ";
        }
        else if (_map._tanks[_id][_curTank].getHealth() < 1)
        {
            nextTank();
            return " ";
        }

        _message = " ";
        loc = _map._tanks[_id][_curTank].getLocation();
        target = _tankPaths[_curTank].getNextNode(loc);
        if (loc.equals(target))
        {
            tankMoving = findNewTarget(_curTank, loc);
        }
        else
            tankMoving = tankMove(_curTank, loc, target);

        if (tankMoving == false)
            nextTank();
        return _message;
    }


// ******************************************
// ***** METHODS - Extended AI Features *****
// ******************************************

    private boolean findNewTarget(int tankNum, Point loc)
    {
        int targetList[] = new int[_factoryStates.length];
        int cntr;

//        System.out.println(_id + " tank " + tankNum + " finding new target!");
        // build list of targets
        int numTargets = 0;
        for (cntr = 0; cntr < _factoryStates.length; ++cntr)
        {
            if (_factoryStates[cntr] == -1)
            {
                targetList[numTargets] = cntr;
                ++numTargets;
            }
        }

        // if one or more, choose and build path
//        System.out.println("chosing from " + numTargets + " targets!");
        if (numTargets > 0)
        {
            int newTarget = targetList[_random.nextInt() % numTargets];
            _factoryStates[newTarget] = tankNum;
            _tankPaths[tankNum] = new Path(_map, loc, _factoryPoints[newTarget], 0);
            return true;
        }
        else
        {
            _message = "Guarding location";
            return tankGuard(tankNum, loc);
        }
    }
}
